#!/bin/bash
O_MD5=d588d6a86c2b0c204d6357e0effb5393

china=`curl -sSL https://github.com/felixonmars/dnsmasq-china-list/raw/master/accelerated-domains.china.conf | while read line; do awk -F '/' '{print $2}' | grep -v '#' ; done |  paste -sd " " -`
apple=`curl -sSL https://github.com/felixonmars/dnsmasq-china-list/raw/master/apple.china.conf | while read line; do awk -F '/' '{print $2}' | grep -v '#' ; done |  paste -sd " " -`
bogus=`curl -sSL https://github.com/felixonmars/dnsmasq-china-list/raw/master/bogus-nxdomain.china.conf | grep "=" | while read line; do awk -F '=' '{print $2}' | grep -v '#' ; done |  paste -sd " " -`
#google=`curl -sSL https://github.com/felixonmars/dnsmasq-china-list/raw/master/google.china.conf | while read line; do awk -F '/' '{print $2}' | grep -v '#' ; done |  paste -sd " " -`

cat>Corefile<<EOF
. {
    hosts {
        fallthrough
    }
    forward . 127.0.0.1:5322 {
    except $china $apple cdn.jsdelivr.net
    }
    proxy . 127.0.0.1:5311
    bogus $bogus
    cache 10
    log
    health
    reload
    errors
}
EOF

N_MD5=`md5sum Corefile|awk '{print $1}'`

[[ "$O_MD5" == "$N_MD5" ]] && exit 0 || docker-compose restart coredns

sed -ri "/^O_MD5/c O_MD5=$N_MD5" $0


